'' =================================================================================================
''
''   File....... jm_dmx_monitor.spin
''   Purpose.... Simple program to monitor DMX channel values
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2009 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 15 SEP 2009
''   Updated.... 20 SEP 2009
''
'' =================================================================================================



con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  
con

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control

  DMX_START = 1                                                 ' monitor channels 1 - 6
  DMX_END   = 6  


obj

  term  : "jm_txserial"
  dmx   : "jm_dmxin"


pub main | chan

  term.init(30, 115_200)                                        ' use programming port
  waitcnt(clkfreq / 10 + cnt)
  term.str(string(CLS, "DMX Monitor"))

  dmx.init(24, 16)                                              ' for DMX IO board'

  repeat
    term.tx(HOME)
    term.tx(LF)
    term.tx(LF)
    
    repeat chan from DMX_START to DMX_END
      term.rjdec(chan, 3)
      term.str(string("   "))
      term.rjdec(dmx.read(chan), 3)
      term.tx(CR)
      
    waitcnt(clkfreq / 100 + cnt)                                ' wait 10ms
  

dat

{{

  Copyright (c) 2009 Jon McPhalen (aka Jon Williams)

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

}}

          